(* tag: dual category *)
Require Export cat.

Implicit Arguments On.

(** ** Dual Category *)

Module Dual_Cat.

Export Cat.

Section Dual_Cat.

Variable A:Cat.

Local dual_mor [x,y:A] : Type := (mor y x).

Local B := (Build_Cat_Data
   [x,y,z:A; g:(dual_mor y z); f:(dual_mor x y)] (oo f g)
   [x:A](ii x)).

Definition Dual_Cat : Cat.
Proof.
  Split with B;
  Abstract Simpl; Unfold dual_mor; Split; Auto.
Defined.

End Dual_Cat.

End Dual_Cat.
