(* tag: poset of setof *)

(** * Poset of Subset *)

Implicit Arguments On.

Require Export poset_.
Require misc_.

Module Poset_Of_Subset_.

Export Poset_.
Import Misc_.

Section Poset_Of_Subset.

Variable A:Type.

Remark leq_subset_poset : (Ax_Poset (!leq_subset A)).
Proof.
  Unfold leq_subset.
  Split; Try Split; EAuto.
  Unfold Ax_Anti_Symmetry.
  Intros.
  Apply nondep_extensionality with A:=A B:=Prop.
  Intro u.
  Apply prop_uni; Auto.
Qed.

Canonical Structure poset_of_subset : Poset.
Proof.
  Split with leq := (!leq_subset A).
  Exact leq_subset_poset.
Defined.

End Poset_Of_Subset.

End Poset_Of_Subset_.
